<template>
  <div class="app-container">
    <el-row :gutter="10" class="mb8" v-if="this.source == 'BoDetails' ? this.bo.winningState == 0 ? true : false : true">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          :disabled="!pojpsnAuthority.pojpsnAdd"
          >新增</el-button
        >
      </el-col>
      <!-- <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          >修改</el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          >删除</el-button
        >
      </el-col> -->
      <!-- <right-toolbar
        :showSearch.sync="showSearch"
        @queryTable="getList"
      ></right-toolbar> -->
    </el-row>

    <el-table
      v-loading="loading"
      :data="pojpsnList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="index" label="序号" width="55" align="center"/>
      <el-table-column
        label="商机名称"
        align="center"
        prop="boName"
        v-if="source == 'Pojpsn'"
      />
      <el-table-column label="员工名称" align="center" prop="staffName" />
      <el-table-column label="项目岗位" align="center" prop="post">
        <template slot-scope="scope">
          <dict-tag
            :options="dict.type.mk_bo_pojpsn_post"
            :value="scope.row.post"
          />
        </template>
      </el-table-column>
      <el-table-column label="职责" align="center" prop="jobs" width="400">
        <template slot-scope="scope">
          <el-select v-model="scope.row.jobs" multiple disabled size="medium">
            <el-option
              v-for="item in mk_bo_pojpsn_job"
              :key="item.code"
              :label="item.name"
              :value="item.code"
            >
            </el-option>
          </el-select>
        </template>
      </el-table-column>
      <el-table-column
        label="操作"
        fixed="right"
        align="center"
        class-name="small-padding fixed-width"
        v-if="this.source == 'BoDetails' ? this.bo.winningState == 0 ? true : false : true"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            :disabled="!pojpsnAuthority.pojpsnEdit"
            >修改</el-button
          >
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            :disabled="!pojpsnAuthority.pojpsnDel"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改项目成员对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <!-- <el-form-item label="商机名称" prop="boName">
          <el-input v-model="form.boName" placeholder="商机名称" />
        </el-form-item> -->
        <el-form-item label="员工" prop="staffName">
          <el-input
            v-model="form.staffName"
            :disabled="this.operatingState != 'Insert'"
          >
            <el-button
              slot="append"
              icon="el-icon-more"
              @click="refereStaff"
              :disabled="this.operatingState != 'Insert'"
            ></el-button>
          </el-input>
        </el-form-item>
        <el-form-item label="项目岗位" prop="post">
          <el-select v-model="form.post" placeholder="请选择项目岗位" disabled>
            <el-option
              v-for="dict in dict.type.mk_bo_pojpsn_post"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="职责" prop="jobs">
          <el-select v-model="form.jobs" multiple placeholder="请选择职责">
            <el-option
              v-for="item in mk_bo_pojpsn_job"
              :key="item.code"
              :label="item.name"
              :value="item.code"
            >
            </el-option>
          </el-select>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm" :disabled="submitButtonEditStatus">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <!-- 员工参照 -->
    <StaffRef
      ref="contractSelect"
      @doSubmit="selectionsToInput"
      :single="true"
    />
  </div>
</template>

<script>
import {
  listPojpsn,
  getPojpsn,
  delPojpsn,
  addPojpsn,
  updatePojpsn,
} from "@/api/business/spd/bo/pojpsn";
import StaffRef from "@/views/business/spd/bo/refer/staff/index.vue";
import { getBoJobListByType } from "@/api/business/spd/bo/boJob";

export default {
  name: "pojpsnList",
  props: ["source", "bo","boAuthority"],
  dicts: ["mk_bo_pojpsn_post",],
  components: { StaffRef },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 项目成员表格数据
      pojpsnList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        bo: null,
        boName: null,
        staffName: null,
        post: null,
        job: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        staffName: [
          { required: true, message: "员工不能为空", trigger: "blur" },
        ],
        post: [{ required: true, message: "岗位不能为空", trigger: "blur" }],
        jobs: [{ required: true, message: "职责不能为空", trigger: "blur" }],
      },
      //当前操作状态
      operatingState: "",
      pojpsnAuthority:{
        pojpsnAdd:true,
        pojpsnDel:true,
        pojpsnEdit:true,
        pojpsnView:true,
      },
      //职责列表
      mk_bo_pojpsn_job:[],
      //确定按钮是否可点
      submitButtonEditStatus:false,
    };
  },
  created() {
    if (this.source == "Pojpsn") {
      this.queryParams = this.bo;
    }
    if (this.source == "BoDetails") {
      this.queryParams.bo = this.bo.id;
      this.pojpsnAuthority = this.boAuthority.boAuthority;
    }
    getBoJobListByType(this.bo.boType).then((response) => {
      this.mk_bo_pojpsn_job = response.rows;
      this.getList();
    });
  },
  methods: {
    /** 查询项目成员列表 */
    getList() {
      this.loading = true;
      listPojpsn(this.queryParams).then((response) => {
        this.pojpsnList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
      this.jobs = [];
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        bo: null,
        boName: null,
        staff: null,
        staffName: null,
        post: null,
        job: null,
        tenantId: null,
        revision: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        delFlag: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.operatingState = "Insert";
      this.reset();
      if (this.source == "BoDetails") {
        this.form.bo = this.bo.id;
        this.form.boName = this.bo.boName;
        this.form.post = "1";
      }
      this.open = true;
      this.title = "添加项目成员";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.operatingState = "Update";
      this.reset();
      const id = row.id || this.ids;
      getPojpsn(id).then((response) => {
        this.form = response.data;
        this.open = true;
        this.title = "修改项目成员";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.submitButtonEditStatus = true;
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.id != null) {
            updatePojpsn(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
              this.submitButtonEditStatus = false;
            });
          } else {
            addPojpsn(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
              this.submitButtonEditStatus = false;
            });
          }
        }else{
          this.submitButtonEditStatus = false;
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal
        .confirm('是否确认删除项目成员编号为"' + ids + '"的数据项？')
        .then(function () {
          return delPojpsn(ids);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        "system/pojpsn/export",
        {
          ...this.queryParams,
        },
        `pojpsn_${new Date().getTime()}.xlsx`
      );
    },
    // 触发员工参照列表
    refereStaff() {
      console.log("测试点击");
      this.$refs.contractSelect.init();
    },
    //员工参照列表选择后
    selectionsToInput(selections) {
      this.form.staff = selections[0].userId;
      this.form.staffName = selections[0].nickName;
    },
  },
};
</script>
